Index: trunk/src/lib/graphics/text_engine/font.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/font.cc	(revision 6315)
+++ trunk/src/lib/graphics/text_engine/font.cc	(revision 6349)
@@ -247,5 +247,5 @@
  * @param fileName the File to write the image into.
  */
-void Font::createAsciiImage(const char* fileName)
+void Font::createAsciiImage(const char* fileName, uint size) const
 {
   if (this->fontTTF == NULL)
@@ -258,5 +258,5 @@
   SDL_Rect tmpRect; // this represents a Rectangle for blitting.
   SDL_Surface* tmpSurf =  SDL_CreateRGBSurface(SDL_SWSURFACE,
-                                               height*16, height*16,
+                                               height*size, height*size,
                                                32,
 #if SDL_BYTEORDER == SDL_LIL_ENDIAN /* OpenGL RGBA masks */
@@ -286,5 +286,5 @@
       {
         SDL_Color white = {255, 255, 255};
-        glyphSurf = TTF_RenderGlyph_Blended(this->fontTTF, posX+16*posY, white);
+        glyphSurf = TTF_RenderGlyph_Blended(this->fontTTF, posX+size*posY, white);
       }
       if( glyphSurf != NULL )
@@ -326,5 +326,5 @@
  * @returns the maximum height of the Font, if the font was initialized, 0 otherwise
  */
-int Font::getMaxHeight()
+int Font::getMaxHeight() const
 {
   if (likely (this->fontTTF != NULL))
@@ -339,5 +339,5 @@
    the ascent is the pixels of the font above the baseline
  */
-int Font::getMaxAscent()
+int Font::getMaxAscent() const
 {
   if (likely(this->fontTTF != NULL))
@@ -352,5 +352,5 @@
    the descent is the pixels of the font below the baseline
  */
-int Font::getMaxDescent()
+int Font::getMaxDescent() const
 {
   if (likely(this->fontTTF != NULL))
Index: trunk/src/lib/graphics/text_engine/font.h
===================================================================
--- trunk/src/lib/graphics/text_engine/font.h	(revision 6315)
+++ trunk/src/lib/graphics/text_engine/font.h	(revision 6349)
@@ -78,12 +78,12 @@
     inline static Font* getDefaultFont() { if (Font::defaultFont == NULL) initDefaultFont(); return Font::defaultFont; };
 
-    void createAsciiImage(const char* fileName);
+    void createAsciiImage(const char* fileName, uint size) const;
     static void initDefaultFont();
     static void removeDefaultFont();
 
   private:
-    int getMaxHeight();
-    int getMaxAscent();
-    int getMaxDescent();
+    int getMaxHeight() const;
+    int getMaxAscent() const;
+    int getMaxDescent() const;
     Glyph* getGlyphMetrics(Uint16 character);
 
Index: trunk/src/lib/graphics/text_engine/text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/text.cc	(revision 6315)
+++ trunk/src/lib/graphics/text_engine/text.cc	(revision 6349)
@@ -199,28 +199,27 @@
     Glyph* tmpGlyph;
     float posX = 0.0f;
+
+    glBegin(GL_QUADS);
     while (likely(*tmpText != '\0'))
     {
       if(likely((tmpGlyph = glyphArray[*tmpText]) != NULL))
       {
-        glBegin(GL_QUADS);
+        glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
+        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), 0);
+
+        glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
+        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), this->getSizeY2D());
+
+        glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
+        glVertex2d(posX, this->getSizeY2D());
 
         glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[2]);
         glVertex2d(posX, 0);
 
-        glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
-        glVertex2d(posX, this->getSizeY2D());
-
-        glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
-        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), this->getSizeY2D());
-
-        glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
-        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), 0);
-
-        glEnd();
-        glEndList();
         posX += tmpGlyph->advance * this->getSizeY2D();
       }
       ++tmpText;
     }
+    glEnd();
   }
 